import pandas as pd
import pymysql


def con_sql(db,sql):
    cursor = db.cursor()
    try:
        cursor.execute(sql)
        result = cursor.fetchall()
        df = pd.DataFrame(list(result))
    except Exception:
        print("发生异常", Exception)
        df = pd.DataFrame()
    finally:
        db.close()
    return df


def exp():
    db = pymysql.connect(host='10.66.157.22', port=4000, user='root', passwd='3SYz54LS9#^9sBvC', db='jerry_test')
    sql = "select manufacturer,channel from user_feature"
    df = con_sql(db, sql)
    n = df.shape[0]
    manufacturer = df[0].unique()
    manufacturer_map = {}
    print("manufacturer unique")
    print(len(manufacturer))
    for i in manufacturer:
        manufacturer_map[i] = df.loc[df[0]==i].shape[0]/n
    print(sorted(manufacturer_map.items(),key = lambda x:x[1]))
    channel = df[1].unique()
    channel_map = {}
    print("channel unique")
    print(len(channel))
    for i in channel:
        channel_map[i] = df.loc[df[1] == i].shape[0] / n
    print(sorted(channel_map.items(), key=lambda x: x[1]))


if __name__ == "__main__":
    exp()


